<?php

/*
* Simple TagCloud plugin
* v. 0.2
* By Kupo/Watt
* Site pgc-cs.eu
* Add tags to your page :>
* Price Free (You have to leave oryginal footer)
*/

define("IN_MYBB", 1);
include_once ("global.php");
require_once "./inc/class_parser.php";
$parser = new postParser;

function sChLim($text, $limit) {
	/** This function make txt shorter after br [so it won't cut links] **/
	$tarray = explode("\n", $text);
	$i = 0;
	$return = "";
	foreach ($tarray as $line) {
		$i = strlen($line) + $i;
		if($i > $limit){
			$return = $return."\n".$line."...";
			break;
			}
		else
			$return = $return."\n".$line;
	
	}

	return $return;
}

function zamiana_html($str)
{
	$str = str_replace('"',"&quot;", $str);
	$str = str_replace("&","&amp;", $str);
	$str = str_replace("<","&lt;", $str);
	$str = str_replace(">","&gt;", $str);

	return $str;
	
}


/*If you are using tags, please do not delete this*/

$list_descrip = array(
		'1' => 'PGC - Serwery Counter-Strike',
		'2' => 'Serwery Counter Strike 1.6 Steam i NonSteam',
		'3' => 'Najlepsze Serwery Counter Strike',
		'4' => 'Counter Strike NonSteam',
		'5' => 'Counter-Strike Servers',
		'6' => 'AMXX, HLDS, poradniki',
		'7' => 'PGC',
		'8' => 'CS 1.6 Non Steam',
		'9' => 'Serwery Non Steam',
		'11' => 'Serwery Non Steam',
		'12' => 'PGC - Serwery Steam',
		'13' => 'Serwery do CS 1.6 Non Steam',
		'14' => 'CS',
		'15' => 'Counter Strike',
		'16' => 'CS NonSteam i Steam',
		'17' => 'Serwery do CS 1.6 Non Steam',
		'18' => 'Counter Strike 1.6 i Source',
		'19' => 'CSS i 1.6',
		'20' => 'Pluginy AMXX i SourceMod',
		'21' => 'Artykuly, Poradniki CS',
		'22' => 'gry online',
		'23' => 'Non Steam',
		'24' => 'Steam',
		'25' => 'Counter Strike Servers'
);

$author = "<a href=\"http://pgc-cs.eu/\" title=\"".$list_descrip[rand(1, 25)]."\">".$list_descrip[rand(1, 25)]."</a>";


function zmiana($tekst){
	
	$tekst = str_replace("`","", $tekst);
	$tekst = str_replace('"',"", $tekst);
	
	/*BBCODE CHANGE!*/
	
	$tekst = preg_replace('#\[b\](.*?)\[/b\]#si','<b>\\1</b>',$tekst);
	$tekst = preg_replace('#\[i\](.*?)\[/i\]#si','<i>\\1</i>',$tekst);
	$tekst = preg_replace('#\[u\](.*?)\[/u\]#si','<u>\\1</u>',$tekst);
	$tekst = preg_replace('#\[s\](.*?)\[/s\]#si','<s>\\1</s>',$tekst);
	
	//preg_match("/[img]", $tekst, $matches);

	//print_r($msimg);
	
	$tekst = preg_replace('#\[url\](http.*?)\[/url\]#si', '<a rel="nofollow" href="\\1">\\1</a>', $tekst);
	$tekst = preg_replace('#\[url=(http.*?)\](.*?)\[/url\]#si', '<a rel="nofollow" href="\\1" target="_blank">\\2</a>', $tekst);
	$tekst = preg_replace('#\[quote\](.*?)\[/quote\]#si','\\1',$tekst);
	$tekst = preg_replace('#\[quote=(.*?)\](.*?)\[/quote\]#si','\\2',$tekst);
	$tekst = preg_replace('#\[color=(.*?)\](.*?)\[/color\]#si','<span style="color:\\1;">\\2</span>',$tekst);
	$tekst = preg_replace('#\[code\](.*?)\[/code\]#si','<code>\\1</code>',$tekst);
	$tekst = preg_replace('#\[size=(.*?)\](.*?)\[/size\]#si','\\2',$tekst);
	
	$tekst = nl2br ( $tekst );
	
	//IMG CHANGE!!//
		$preg = preg_match_all("/\[img\]([^\[]+?)\[\/img\]/is", $tekst, $msimg);
	$i = 0;
	$obrazki = array();

	if($preg){
	
		foreach($msimg as $for1)
		{
			foreach($for1 as $for2)
			{
				if(!strstr($for2, "[img]") || strstr($for2, "[IMG]"))
				{							
						if (!@fclose(@fopen($for2, "r"))) 
							continue 1;
							
						$for2_len = strlen($for2);
						
						if(substr($for2, ($for2_len-5), $for2_len) == ".html" || substr($for2, ($for2_len-4), $for2_len) == ".php") // fast solution need to be remaked :D
							continue 1;
						
						
						$wymiar = getimagesize($for2);
						$for2_save = $for2;

						$for2 = str_replace("/", "\\/", $for2); //zamiana linkow do obrazka :>
						if($wymiar[0] > 200)
						{
							$ile_procent = (200 * 100) / $wymiar[0];
							$ile_procent = (int) $ile_procent;
							$wymiar[0] = 200;
							$wymiar[1] = (int) $wymiar[1] * ($ile_procent / 100);
							$wymiar[1] = (int) $wymiar[1];
							$tekst = preg_replace('#\[img\]'.$for2.'\[/img\]#si','<img src="'.$for2_save.'" alt="" width="'.$wymiar[0].'" height="'.$wymiar[1].'">',$tekst);
						
						}elseif($wymiar[1] > 150){
							$ile_procent = (150 * 100) / $wymiar[1];
							$ile_procent = (int) $ile_procent;		
							$wymiar[1] = 150;
							$wymiar[0] = $wymiar[0] * ($ile_procent / 100);
							$wymiar[0] = (int) $wymiar[0];

							$tekst = preg_replace('#\[img\]'.$for2.'\[/img\]#si','<img src="'.$for2_save.'" alt="" width="'.$wymiar[0].'" height="'.$wymiar[1].'">',$tekst);
							
						}else{
							$tekst = preg_replace('#\[img\]'.$for2.'\[/img\]#si','<img src="'.$for2.'" alt="">',$tekst);
						}
						
						//Dont know if it is good I'm not good at it:<

				}
			}
		}

	}
	
	/***********************IMG END*******************************/
	
	//rest
	$tekst = preg_replace('#\[(.*?)\](.*?)\[/(.*?)\]#si','\\2',$tekst);
	
	//rubbish
	$tekst = preg_replace('#\[(.*?)\](.*?)#si','\\2',$tekst);
	$tekst = preg_replace('#\[/(.*?)\](.*?)#si','\\2',$tekst);
	
	return $tekst;
	
	/**************END****************/
}


/**KEYWORDS LOADING**/
global $db, $mybb;

	/* Keywords, forum link, path loading*/
	
	$tag_keywords = $mybb->settings['stcp_keywords'];		
	//$tag_keywords = str_replace(" ","",$tag_keywords); if you want uncomment it
	$tag_keywords_s = $tag_keywords;
	$tag_keywords = explode(",",$tag_keywords);
	$tag_liczba_elementow = count($tag_keywords)-1;
	
	$link_forum = $mybb->settings['bburl'];
	$link_forum_leng = strlen($link_forum);
	$link_forum_last = substr($link_forum, $link_forum_leng-1, $link_forum_leng-1);
	if($link_forum_last != "/")
		$link_forum = $link_forum."/";
	
	$path = $mybb->settings['stcp_path'];
	$stcp_page = $mybb->settings['stcp_page'];	
	
	/* END */

$thread = $db->escape_string($mybb->input['thread']);
$insert = $db->escape_string($mybb->input['insert']);
$word = $db->escape_string($mybb->input['tag']);
$rand = $db->escape_string($mybb->input['rand']);

if($thread){
	$thread = str_replace("  "," ", $thread);
	$thread = str_replace(" ",", ", $thread);
	$thread = str_replace(",,",',', $thread);
	$thread = str_replace("'","", $thread);
	$thread = str_replace("_","-", $thread);
	$thread = str_replace(";","", $thread);
	$thread = str_replace("|","", $thread);
	$thread = str_replace("/","", $thread);
	$thread = str_replace(":","", $thread);
	$thread = str_replace("<","", $thread);
	$thread = str_replace(">","", $thread);
	$thread = str_replace('"',"", $thread);
	$thread = str_replace("=","-", $thread);
	$thread = str_replace("`","", $thread);
	$thread = str_replace("}","", $thread);
	$thread = str_replace("{","", $thread);
	$thread = str_replace("]","", $thread);
	$thread = str_replace("[","", $thread);
	$thread = str_replace("?", "", $thread);
	$thread = str_replace("%", "", $thread);
	$thread = str_replace("&", "", $thread);	
	$thread = str_replace("(", "", $thread);
	$thread = str_replace(")", "", $thread);
	$thread = str_replace("^", "", $thread);
	$thread = str_replace(",,",',', $thread);	
	
	$explode_tags = explode(", ", $thread);
	unset($thread);
	foreach ($explode_tags as $one_tag)
	{
		if(!$one_tag || $one_tag == " ")// If it's empty
			continue 1;
				
		$one_tag_len = strlen($one_tag);
			
		if($one_tag_len <= $mybb->settings['stcp_smallwords']){ // Check anount of characters
			$text=$one_tag."<br />".$text;
		}else{
			$thread = $thread.", ".$one_tag;	
		}
			
			
	}
	/* Do not leave last comma */
	$thread_leng = strlen($thread);
	$link_forum_last = substr($thread, $thread_leng-1, $thread_leng-1);
	if($link_forum_last == ",")
		$thread = substr($thread, 0, $thread_leng-1);
		
	/* Do not leave first space */		
	$link_forum_first = substr($thread, 0, 1);	
	if($link_forum_first == " " || $link_forum_first == "-" || $link_forum_first == "," || $link_forum_first == ", ")
		$thread = substr($thread, 1, $thread_leng);	
	
	$link_forum_first = substr($thread, 0, 1);
	if($link_forum_first == " ")// will be replaced in nex verions ;p
		$thread = substr($thread, 1, $thread_leng);	
	
	echo $thread;
}elseif($insert){
	if($mybb->usergroup['cancp'] != 1 || !$stcp_page)
	{
		die();
	}
	$zapytanie = $db->query("SELECT tid, subject, tag FROM `".TABLE_PREFIX."threads`");
	while($fetch = $db->fetch_array($zapytanie))
	{
		if($fetch['tag'])
			continue 1;
			
		$subject = $fetch['subject'];
		$subject = str_replace(",","", $subject);
		$tag_ex = explode(" ", $subject);
		foreach($tag_ex as $one_tag)
			$tag = $one_tag.",".$tag;
		
		$tag = str_replace(", ",",", $tag);
		$tag = str_replace(" ,",",", $tag);
		$tag = str_replace("  "," ", $tag);
		$tag = str_replace(" ","-", $tag);
		$tag = str_replace("'","", $tag);
		$tag = str_replace("_","-", $tag);
		$tag = str_replace(";","", $tag);
		$tag = str_replace("|","", $tag);
		$tag = str_replace("/","", $tag);
		$tag = str_replace(":","", $tag);
		$tag = str_replace("<","", $tag);
		$tag = str_replace(">","", $tag);
		$tag = str_replace('"',"", $tag);
		$tag = str_replace("=","-", $tag);
		$tag = str_replace("`","", $tag);
		$tag = str_replace("}","", $tag);
		$tag = str_replace("{","", $tag);
		$tag = str_replace("]","", $tag);
		$tag = str_replace("[","", $tag);
		$tag = str_replace("?", "", $tag);
		$tag = str_replace("%", "", $tag);
		$tag = str_replace("&", "", $tag);	
		$tag = str_replace("(", "", $tag);
		$tag = str_replace(")", "", $tag);
		$tag = str_replace("^", "", $tag);
		$tag = str_replace(",,",',', $tag);	
		
		$explode_tags = explode(",", $tag);
		unset($tag);
		foreach ($explode_tags as $one_tag)
		{
			if(!$one_tag || $one_tag == " ")// If it's empty
				continue 1;
				
			$one_tag_len = strlen($one_tag);
			
			//if($one_tag_len <= $mybb->settings['stcp_smallwords']) doesnt want to work
			if($one_tag_len <= $mybb->settings['stcp_smallwords']){
				$text=$one_tag.", ".$text;
			}else{
				$tag = $one_tag.",".$tag;	
			}
			
			
		}
		$tag_leng = strlen($tag);
		$link_forum_last = substr($tag, $tag_leng-1, $tag_leng-1);
		if($link_forum_last == ",")
		$tag = substr($tag, 0, $tag_leng-1);
		
		$tag = trim($tag);

		$tag = $db->escape_string($tag);
		$db->query("UPDATE ".TABLE_PREFIX."threads SET tag = '".$tag."' WHERE tid='".$fetch['tid']."'");
		unset($tag);
	}
	$text = "<table border=\"0\" class=\"tborder\"><tr><td class=\"tcat\">Tags:</td></tr><tr><td class=\"trow2\" width=\"100%\">Tags added. :><br /><b>Excluded words:</b><br />".$text."</td></tr></table>";
	eval("\$get_temp = \"".$templates->get("stcp")."\";");	
	output_page($get_temp);
	
}elseif($word){
	$bread = "<a href=\"".$link_forum.$path."/\" title=\"TagCloud\">Simple TagCloud</a> / ".$word;
	add_breadcrumb($bread); 
	$page = $db->escape_string($mybb->input['page']);
	$page = (int) $page;
	
	if($stcp_page > 0){
	$stcp_page = (int) $stcp_page;
		if($page <= 0)
			$page = 1;
		$exclude_page = ($page - 1) * $stcp_page;
		$limit = "LIMIT ".$exclude_page.", ".$stcp_page;
	}else{
		$limit = "";
	}
	

	$zapytanie = $db->query("SELECT fid, tid,tag, subject FROM `".TABLE_PREFIX."threads` WHERE tag LIKE '%".$word."%' ".$limit);
	while($fetch = $db->fetch_array($zapytanie))
	{
		/*Check if thread is accsable for public view*/
		$permission_query = $db->query("SELECT canview FROM `".TABLE_PREFIX."forumpermissions` WHERE fid=".$fetch['fid']." ");
		$fet_permission_query = $db->fetch_array($permission_query);	
		
		if($fet_permission_query['canview'] === "0")
			continue 1;
		/*End checking*/
		
		/*Geting a thread post and author */
		
		$post_query = $db->query("SELECT message, uid, username FROM `".TABLE_PREFIX."posts` WHERE tid=".$fetch['tid']);
		$fet_post_query = $db->fetch_array($post_query);
		
		/* I like to be sure :P */
		if(!$fet_post_query['message'])
			continue 1;
		$userid = $fet_post_query['uid'];
		
		$message = zmiana($fet_post_query['message']); // Replacing post to good form :P
		$message = wordwrap($message, 100, "\n", true); // I dont want to have resized table
		$username = get_user($userid);
		$user = "<a rel=\"nofollow\" href=\"".$link_forum."member.php?action=profile&uid=".$userid."\">".$username['username']."</a>";// nofollow 4 google - users dont make traffic
		
		$threadlink = "<a href=\"".$link_forum.get_thread_link($fetch['tid'])."\" title=\"".zamiana_html($fetch['subject'])."\">".zamiana_html($fetch['subject'])."</a> - ".$user."\n";
		
		/* Now we have to explode tags */
		$exploded_tags = explode(",", $fetch['tag']);
		foreach($exploded_tags as $one_tag)
		{
			if(!$one_tag || $one_tag==" ")
				continue 1;
			
			$one_tag_s = $one_tag;
			$one_tag = str_replace("-", " ", $one_tag); // replacing bigger than 1 word tag
			$tagslink.="<a href=\"".$link_forum.$path."/".$one_tag_s."\" title=\"".$one_tag."\">".$one_tag."</a>, \n";
			
			/*Making Tag Threads in very not-optymalized way :<, any suggestions ? */	
			$i = 0;
			if($i < "10")
			{				
				if(strstr($one_tag , $word))
				continue 1;

				$similar_query = $db->query("SELECT fid,tid,tag,subject FROM `".TABLE_PREFIX."threads` WHERE subject LIKE '%".$one_tag."%' LIMIT 8") or die('kupa');
				while($fetch_similar_query = $db->fetch_array($similar_query))
				{
					if(!strstr($fetch_similar_query['subject'],$word)){
						$similar_tag_desc=$one_tag.", ".$similar_tag_desc;
						$similar_topics = "\n <a title=\"".$fetch_similar_query['subject']." - ".$tag_keywords[rand(0, $tag_liczba_elementow)]."\" href=\"".$link_forum.get_thread_link($fetch_similar_query['tid'])."\">".$fetch_similar_query['subject']."</a>, ".$similar_topics;
					}
				}
			$i++;
			}
		
		}
		eval("\$txt = \"".$templates->get("stcp-tag")."\";");
		$text=$txt.$text;
		unset($tagslink);
	}	

	
	/*Pages */
	$query = $db->query("SELECT fid, tid,tag, subject FROM `".TABLE_PREFIX."threads` WHERE tag LIKE '%".$word."%'"); // Any better Ideas PM me :P
	$rows_number = $db->num_rows($query); 
	$number_of_pages = ceil($rows_number / $stcp_page);
	$z = 1; // pages are from 1 to xxx, no 0 - xxx
	for($z; $z < $number_of_pages+1; $z++){// show all pages
		if($z === $page)
			$pages.="<a href=\"".$link_forum.$path."/".$word."/".$z."\" title=\"".$word." page ".$z."\"><u>".$z."</u></a> ";// if we are looking at page
		else
			$pages.="<a href=\"".$link_forum.$path."/".$word."/".$z."\" title=\"".$word." page ".$z."\">".$z."</a> ";
			
	}
	$pages = "Page: ".$pages;
	/* END PAGES */
	
	/* ------OTHER----- */
	$text = "<table border=\"0\" class=\"tborder\"><tr><td class=\"tcat\" width=\"80%\">Thread / Author </td><td class=\"tcat\" width=\"20%\">Tags</td></tr>".$text."</table>";
	if($similar_tag_desc) // Let's make a meta description
	{
		$similar_tag_desc = "Related tags: ".$similar_tag_desc;
	}else{
		$similar_tag_desc = "Come and see our forum .";
	}
	if(!$similar_topics)
		$similar_topics = "None.";
		
	$similar_topics = "<table border=\"0\" class=\"tborder\"><tr><td class=\"tcat\" width=\"100%\">Similar Thread Tags</td></tr><tr><td class=\"trow1\">".$similar_topics."</td></tr></table>";
	
	/*If no results*/
	if(!$threadlink){
		$text="<table class=\"tborder\" border=\"0\"><tr><td class=\"trow2\"><br />I haven't found any tags.</td></tr></table>";
		$pages = "";
	}
	/* ----------- */
	
	
	/* ---------------- */
	
	/*ADV*/
	$avd_query = $db->query("SELECT title, template FROM ".TABLE_PREFIX."templates");
	while($avd_fet = $db->fetch_array($avd_query))
	{
		if($avd_fet['title'] == 'stcp' && !strstr($avd_fet['template'],'$author'))
		{
			$dodaj = $avd_fet['template'].'<br /><strong>Simple TagCloud Plugin by Kupo - {$author}</strong>';
			$dodaj = mysql_escape_string(stripslashes($dodaj));
			$db->query('UPDATE '.TABLE_PREFIX.'templates SET `template` = "'.$dodaj.'" WHERE `title` = "'.$avd_fet['title'].'"');		
		}
	}
	
	eval("\$get_temp = \"".$templates->get("stcp")."\";");	
	output_page($get_temp);
	
}else{
	add_breadcrumb("Simple TagCloud"); 
	$zapytanie = $db->query("SELECT fid, tid,tag, subject FROM `".TABLE_PREFIX."threads` LIMIT 500");
	while($fetch = $db->fetch_array($zapytanie))
	{
		$exploded_tags = explode(",", $fetch['tag']);
		foreach($exploded_tags as $one_tag)
		{
			if(!$one_tag || $one_tag==" ")
				continue 1;
			
			$one_tag_s = $one_tag;
			$one_tag = str_replace("-", " ", $one_tag); // replacing bigger than 1 word tag
			$tagslink.="<a href=\"".$link_forum.$path."/".$one_tag_s."\" title=\"".$one_tag."\">".$one_tag."</a> | \n";
		
		}
	}
	$text = "<table border=\"0\" class=\"tborder\"><tr><td class=\"tcat\">Tags:</td></tr><tr><td class=\"trow2\" width=\"100%\">".$tagslink."</td></tr></table>";
	$word = "Forum tags";
	eval("\$get_temp = \"".$templates->get("stcp")."\";");	
	output_page($get_temp);
}





